package com.dsic.gj_erp.bean.sy;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * @version V1.0.0
 * @Title: DmEmployee
 * @Package com.dsic.xzerp.bean.sy
 * @Description: 管系制造员工
 * @author: 张恩铭
 * @date: 2021/4/1 15:49
 */
@Data
@ApiModel("管系制造员工")
public class DmEmployee implements Serializable {

    @ApiModelProperty("id")
    @TableId(type = IdType.ASSIGN_UUID)
    private String id;

    @ApiModelProperty("部门科室编码")
    private String departCode;

    @ApiModelProperty("职号")
    private String employeeNo;

    @ApiModelProperty("姓名")
    private String employeeName;

    @ApiModelProperty("性别")
    private String gender;

    @ApiModelProperty("在职状态")
    private Integer employeeStatus;

    @ApiModelProperty("岗位")
    private String position;

    @ApiModelProperty("责任区域")
    private String zone;//责任区域对应字典ZRQY 1:船装;2:机装;3:局装

    @ApiModelProperty("职称")
    private String title;

    @ApiModelProperty("座机电话")
    private String landlinePhone;

    @ApiModelProperty("移动电话")
    private String mobilePhone;

    @ApiModelProperty("备注")
    private String remark;
}
