package com.dsic.gj_erp.controller.jcsj;


import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.EmSbrydyp;
import com.dsic.gj_erp.service.jcsj.EmSbrydypService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@RestController
@RequestMapping("/emSbrydyp")
@Api(tags = "设备人员信息")
public class EmSbrydypController {
    @Autowired
    EmSbrydypService emSbrydypService;

    @ApiOperation(value = "查询")
    @PostMapping(value = "/getList")
    public ResultBean getList(@RequestBody JSONObject json) {
        List<EmSbrydyp> emSbjbbs= emSbrydypService.getList(json);
        return new ResultBean(emSbjbbs);
    }

    @ApiOperation(value = "批量新增")
    @AuthFunction()
    @PostMapping(value = "/save")
    public ResultBean save(@RequestBody List<EmSbrydyp> emSbrydyps, HttpServletRequest request) {
        emSbrydypService.save(emSbrydyps,request);

        return new ResultBean();
    }

    @ApiOperation(value = "批量修改")
    @PostMapping(value = "/update")
    public ResultBean update(@RequestBody List<EmSbrydyp> emSbrydyps) {
        emSbrydypService.update(emSbrydyps);

        return new ResultBean();
    }

    @ApiOperation(value = "批量删除")
    @PostMapping(value = "/delete")
    public ResultBean delete(@RequestBody List<EmSbrydyp> emSbrydyps) {
        emSbrydypService.delete(emSbrydyps);

        return new ResultBean();
    }

    @ApiOperation(value = "机构下人员人员信息")
    @PostMapping(value = "/getRYList")
    public ResultBean delete() {
        List<Map> mapList= emSbrydypService.getRYList();

        return new ResultBean(mapList);
    }
}

