package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmYdjh;
import com.dsic.gj_erp.bean.pgd.PgdQgjh;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.pgd.PgdQgjhService;
import com.dsic.gj_erp.service.zyjh.ZyjhService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@RestController
@RequestMapping("/pgdQgjh")
public class PgdQgjhController {
    
    @Autowired
    PgdQgjhService pgdQgjhService;

    @Autowired
    ZyjhService zyjhService;

    @PostMapping("comLph")
    @AuthFunction
    public ResultBean comLph(HttpServletRequest req, @RequestBody List<DmYdjh> list) throws Exception, CustomException {
        String yhdm = (String) req.getAttribute("yhdm");
        String date= DateUtil.date().toString("yyyy/MM/dd");
        List<DmYdjh> collect = list.stream().map(item -> {
            DmYdjh dmYdjh = new DmYdjh();
            dmYdjh.setId(item.getId());
            dmYdjh.setLphqrry(yhdm);
            dmYdjh.setLphqrrq(date);
            return dmYdjh;
        }).collect(Collectors.toList());

        zyjhService.updateBatchById(collect);

        return new ResultBean();
    }
    
    
    @PostMapping("/getQgPgd")
    @ResponseBody
    public ResultBean getQgPgd(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
        QueryWrapper<PgdQgjh> qw =new QueryWrapper<>();


        qw.eq(StrUtil.isNotEmpty((String)map.get("dcch")),"czbh",(String)map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("pl")),"pl",(String)map.get("pl"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("fd")),"fd",(String)map.get("fd"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("zt")),"zt",(String)map.get("zt"));
        qw.orderBy(true,true,"czbh","pl","fd");
        return new ResultBean(pgdQgjhService.list(qw));

    }

    @PostMapping("/saveQgPgdXd")
    @ResponseBody
    @AuthFunction
    public ResultBean saveQgPgdXd(HttpServletRequest req, @RequestBody List<PgdQgjh> list) throws Exception, CustomException {
        pgdQgjhService.saveQgPgdXd(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveQgPgdXdBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveQgPgdXdBack(HttpServletRequest req, @RequestBody List<PgdQgjh>list) throws Exception, CustomException {
        pgdQgjhService.saveQgPgdXdBack(list,req);
        return new ResultBean();
    }



    @PostMapping("/saveQgPgdFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveQgPgdFk(HttpServletRequest req, @RequestBody List<PgdQgjh>list) throws Exception, CustomException {
        pgdQgjhService.saveQgPgdFk(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveQgdFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveQgdFk(HttpServletRequest req, @RequestBody List<PgdQgjh>list) throws Exception, CustomException {
        pgdQgjhService.saveQgdFk(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveQgjhPg")
    @ResponseBody
    @AuthFunction
    public ResultBean saveQgjhPg(HttpServletRequest req, @RequestBody List<PgdQgjh>list) throws Exception, CustomException {
        pgdQgjhService.saveQgjhPg(list,req);
        return new ResultBean();
    }
    @PostMapping("/saveQgjhPgBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveQgjhPgBack(HttpServletRequest req, @RequestBody List<PgdQgjh>list) throws Exception, CustomException {
        pgdQgjhService.saveQgjhPgBack(list,req);
        return new ResultBean();
    }


}

