package com.dsic.gj_erp.controller.txzz;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.txzz.DmProject;
import com.dsic.gj_erp.service.txzz.DmProjectService;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 船只信息 前端控制器
 * </p>
 *
 * @author xhj
 * @since 2021-03-19
 */


@RestController
@RequestMapping(value = "/api/gj/dmProject")
@Api(tags = "船只信息controller")
public class DmProjectController {
    @Autowired
    DmProjectService dmProjectService;

    @PostMapping(value = "/getTreeList")
    public ResultBean getDictTreeListDict(@RequestBody Map<String, Object> params) {
        return new ResultBean( dmProjectService.getProjectTree(params));

    }


    @PostMapping(value = "/getProjectDown")
    public ResultBean getDictProjectDownDict(@RequestBody Map<String, Object> params) {

        QueryWrapper<DmProject> qw = new QueryWrapper<DmProject>();
        qw.select("project","factory_area","classs","owner","project_type","finish_flag");
        //qw.orderByDesc("finish_flag")
          //   qw. orderBy("age");
        qw.orderBy(true,true,"finish_flag","length(project)","project");
        qw.apply("IFNULL(project,'')<>''");
        return new ResultBean( dmProjectService.list(qw));

    }

    /**
     * 条件查询
     * @author 张恩铭
     * @param dmProject
     * @return
     */
    @PostMapping("/getcon")
    public ResultBean<List<DmProject>> getByCon(@RequestBody DmProject dmProject){
        return this.dmProjectService.getByCondition(dmProject);
    }

    /**
     * 只查船号
     * @author 张恩铭
     * @return
     */
    @PostMapping("/getpro")
    public ResultBean<List<DmProject>> getAllProject(){
        return this.dmProjectService.getAllProject();
    }

    /**
     * 修改管系部分
     * @param dmProjects
     * @return
     */
    @PostMapping("/update")
    public ResultBean<Integer> updateProject(@RequestBody DmProject[] dmProjects){
        return this.dmProjectService.updateProject(dmProjects);
    }

}

